package gov.llnl.babel.ast;

import gov.llnl.babel.parsers.sidl2.ParseTreeNode;
import gov.llnl.babel.visitor.Visitor;

import java.util.LinkedList;

/**
 * Has no implementation, and all methods are virtual.
 */
public class InterfaceType extends Extendable {
  
  /** a list of ScopedID's */
  protected LinkedList d_extends = null;
  
	public InterfaceType(ParseTreeNode src, ASTNode parent, Name name) {
		super(src, parent, name);
    d_extends = new LinkedList();
	}

  public String getTypeName() { 
    return "interface";
  }
  
  /** returns a linked list of ScopedID's */
  public LinkedList getExtends() { 
    return d_extends;
  }
  
	public Object accept(Visitor v, Object data) {
		return v.visitInterfaceType( this, data );
	}
}
