  //
  // File:        SIDLDumpVisitor.java
  // Package:     
  // Copyright:   (c) 2005 The Regents of the University California
  // Release:     $Name$
  // Revision:     @(#) $Id$
  // Description: 

package gov.llnl.babel.parsers.sidl2;

import java.io.PrintStream;

public class SIDLDumpVisitor implements SIDLParserVisitor { 
  
    protected PrintStream out;

    private int indent = 0;
    
    public SIDLDumpVisitor ( PrintStream o ) { 
        out = o;
    }

    private String indentString() {
        StringBuffer sb = new StringBuffer();
        for (int i = 0; i < indent; ++i) {
            sb.append(" ");
        }
        return sb.toString();
    }

    public Object visit( ParseTreeNode node, Object data) { 
    	if ( node.name.equals("") ) { 
    		out.println(indentString() + node + node.doc );
    	} else { 
    		out.println(indentString() + node + "  (" + node.name + ")" + node.doc);
    	}
        ++indent;
        data = node.childrenAccept(this, data);
        --indent;
        return data;
    }
}
