/*
 * File:          sort_QuickSort_Impl.c
 * Symbol:        sort.QuickSort-v0.1
 * Symbol Type:   class
 * Babel Version: 0.11.0
 * Description:   Server-side implementation for sort.QuickSort
 * 
 * WARNING: Automatically generated; only changes within splicers preserved
 * 
 * babel-version = 0.11.0
 */

/*
 * DEVELOPERS ARE EXPECTED TO PROVIDE IMPLEMENTATIONS
 * FOR THE FOLLOWING METHODS BETWEEN SPLICER PAIRS.
 */

/*
 * Symbol "sort.QuickSort" (version 0.1)
 * 
 * Quick sort
 */

#include "sort_QuickSort_Impl.h"

#line 26 "../../../../babel_0_11_0_final/regression/sort/libC/sort_QuickSort_Impl.c"
/* DO-NOT-DELETE splicer.begin(sort.QuickSort._includes) */
#include "sort_Container.h"
#include "sort_Counter.h"
#include "sort_Comparator.h"
#include "sidl_String.h"
#include <stdio.h>
#include "sidl_Exception.h"

/**
 * Choose the middle of the first, middle and last element of the
 * list.  For small lists, return the middle without checking.
 */
static int32_t
choosePivot(sort_Container  elems,
            sort_Comparator comp,
            sort_Counter    cmp,
            int32_t         start,
            int32_t         end, 
            sidl_BaseInterface *_ex)
{
  int32_t pivot = (start + end) >> 1;
  if ((end - start) > 4) {
    int32_t mid = pivot;
    sort_Counter_inc(cmp, _ex); SIDL_CHECK(*_ex);
    if (sort_Container_compare(elems, start, mid, comp, _ex) <= 0) {
      SIDL_CHECK(*_ex);
      sort_Counter_inc(cmp, _ex); SIDL_CHECK(*_ex);
      if (sort_Container_compare(elems, mid, end - 1, comp, _ex) > 0) {
        SIDL_CHECK(*_ex);
        sort_Counter_inc(cmp, _ex); SIDL_CHECK(*_ex);
        if (sort_Container_compare(elems, start, end - 1, comp, _ex) < 0) {
          SIDL_CHECK(*_ex);
          pivot = end - 1;
        }
        else {
          SIDL_CHECK(*_ex);
          pivot = start;
        }
      }
    }
    else {
      SIDL_CHECK(*_ex);
      sort_Counter_inc(cmp, _ex); SIDL_CHECK(*_ex);
      if (sort_Container_compare(elems, mid, end - 1, comp, _ex) < 0) {
        SIDL_CHECK(*_ex);
        sort_Counter_inc(cmp, _ex); SIDL_CHECK(*_ex);
        if (sort_Container_compare(elems, start, end - 1, comp, _ex) > 0) {
          SIDL_CHECK(*_ex);
          pivot = end - 1;
        }
        else {
          SIDL_CHECK(*_ex);
          pivot = start;
        }
      }
    }
  }
 EXIT:
  return pivot;
}

static void 
quickSort(sort_Container  elems,
          sort_Comparator comp,
          sort_Counter    cmp,
          sort_Counter    swp,
          int32_t         start,
          int32_t         end,
          sidl_BaseInterface *_ex)
{
  if ((end - start) > 1) {
    int32_t pivot = choosePivot(elems, comp, cmp, start, end, _ex); SIDL_CHECK(*_ex);
    int32_t i = start;
    int32_t j = end;
    if (pivot != start) {
      sort_Counter_inc(swp, _ex); SIDL_CHECK(*_ex);

      sort_Container_swap(elems, start, pivot, _ex); SIDL_CHECK(*_ex);
    }
    for(;;) {
      do {
        SIDL_CHECK(*_ex);
        --j;
        sort_Counter_inc(cmp, _ex); SIDL_CHECK(*_ex);
      } while (sort_Container_compare(elems, start, j, comp, _ex) < 0);
      SIDL_CHECK(*_ex);
      while (++i < j) {
        const int icmp = sort_Container_compare(elems, start, i, comp, _ex); 
        SIDL_CHECK(*_ex);
        sort_Counter_inc(cmp, _ex); SIDL_CHECK(*_ex);
        if (icmp < 0) break;
      }
      if (i >= j) break;
      sort_Counter_inc(swp, _ex); SIDL_CHECK(*_ex);
      sort_Container_swap(elems, i, j, _ex); SIDL_CHECK(*_ex);
    }
    if (j != start) {
      sort_Counter_inc(swp, _ex); SIDL_CHECK(*_ex);
      sort_Container_swap(elems, start, j, _ex); SIDL_CHECK(*_ex);
    }
    quickSort(elems, comp, cmp, swp, start, j, _ex); SIDL_CHECK(*_ex);
    quickSort(elems, comp, cmp, swp, j + 1, end, _ex); SIDL_CHECK(*_ex);
  }
 EXIT:;
}
/* DO-NOT-DELETE splicer.end(sort.QuickSort._includes) */
#line 133 "sort_QuickSort_Impl.c"

/*
 * Static class initializer called exactly once before any user-defined method is dispatched
 */

#undef __FUNC__
#define __FUNC__ "impl_sort_QuickSort__load"

#ifdef __cplusplus
extern "C"
#endif
void
impl_sort_QuickSort__load(
  /* out */ sidl_BaseInterface *_ex)
{
  *_ex = 0;
#line 148 "../../../../babel_0_11_0_final/regression/sort/libC/sort_QuickSort_Impl.c"
  /* DO-NOT-DELETE splicer.begin(sort.QuickSort._load) */
  /* Insert the implementation of the static class initializer method here... */
  /* DO-NOT-DELETE splicer.end(sort.QuickSort._load) */
#line 154 "sort_QuickSort_Impl.c"
}
/*
 * Class constructor called when the class is created.
 */

#undef __FUNC__
#define __FUNC__ "impl_sort_QuickSort__ctor"

#ifdef __cplusplus
extern "C"
#endif
void
impl_sort_QuickSort__ctor(
  /* in */ sort_QuickSort self,
  /* out */ sidl_BaseInterface *_ex)
{
  *_ex = 0;
#line 168 "../../../../babel_0_11_0_final/regression/sort/libC/sort_QuickSort_Impl.c"
  /* DO-NOT-DELETE splicer.begin(sort.QuickSort._ctor) */
  /* Insert the implementation of the constructor method here... */
  /* DO-NOT-DELETE splicer.end(sort.QuickSort._ctor) */
#line 176 "sort_QuickSort_Impl.c"
}

/*
 * Class destructor called when the class is deleted.
 */

#undef __FUNC__
#define __FUNC__ "impl_sort_QuickSort__dtor"

#ifdef __cplusplus
extern "C"
#endif
void
impl_sort_QuickSort__dtor(
  /* in */ sort_QuickSort self,
  /* out */ sidl_BaseInterface *_ex)
{
  *_ex = 0;
#line 189 "../../../../babel_0_11_0_final/regression/sort/libC/sort_QuickSort_Impl.c"
  /* DO-NOT-DELETE splicer.begin(sort.QuickSort._dtor) */
  /* Insert the implementation of the destructor method here... */
  /* DO-NOT-DELETE splicer.end(sort.QuickSort._dtor) */
#line 199 "sort_QuickSort_Impl.c"
}

/*
 * Sort elements using Quick Sort.
 */

#undef __FUNC__
#define __FUNC__ "impl_sort_QuickSort_sort"

#ifdef __cplusplus
extern "C"
#endif
void
impl_sort_QuickSort_sort(
  /* in */ sort_QuickSort self,
  /* in */ sort_Container elems,
  /* in */ sort_Comparator comp,
  /* out */ sidl_BaseInterface *_ex)
{
  *_ex = 0;
#line 212 "../../../../babel_0_11_0_final/regression/sort/libC/sort_QuickSort_Impl.c"
  /* DO-NOT-DELETE splicer.begin(sort.QuickSort.sort) */
  sort_Counter cmp = NULL;
  sort_Counter swp = NULL;
  const int32_t num = sort_Container_getLength(elems, _ex); SIDL_CHECK(*_ex);
  cmp = sort_QuickSort_getCompareCounter(self, _ex); SIDL_CHECK(*_ex);
  swp = sort_QuickSort_getSwapCounter(self, _ex); SIDL_CHECK(*_ex);
  quickSort(elems, comp, cmp, swp, 0, num, _ex); SIDL_CHECK(*_ex);
 EXIT:
  {
    sidl_BaseInterface throwaway_exception;
    if (cmp) sort_Counter_deleteRef(cmp, &throwaway_exception);
    if (swp) sort_Counter_deleteRef(swp, &throwaway_exception);
  }
  /* DO-NOT-DELETE splicer.end(sort.QuickSort.sort) */
#line 235 "sort_QuickSort_Impl.c"
}

/*
 * Return quick sort.
 */

#undef __FUNC__
#define __FUNC__ "impl_sort_QuickSort_getName"

#ifdef __cplusplus
extern "C"
#endif
char*
impl_sort_QuickSort_getName(
  /* in */ sort_QuickSort self,
  /* out */ sidl_BaseInterface *_ex)
{
  *_ex = 0;
#line 244 "../../../../babel_0_11_0_final/regression/sort/libC/sort_QuickSort_Impl.c"
  /* DO-NOT-DELETE splicer.begin(sort.QuickSort.getName) */
  return sidl_String_strdup("Quick sort");
  /* DO-NOT-DELETE splicer.end(sort.QuickSort.getName) */
#line 258 "sort_QuickSort_Impl.c"
}
/* Babel internal methods, Users should not edit below this line. */
struct sidl_BaseClass__object* 
  impl_sort_QuickSort_fconnect_sidl_BaseClass(const char* url, sidl_bool ar,
  sidl_BaseInterface *_ex) {
  return sidl_BaseClass__connectI(url, ar, _ex);
}
struct sidl_BaseClass__object* impl_sort_QuickSort_fcast_sidl_BaseClass(void* 
  bi, sidl_BaseInterface* _ex) {
  return sidl_BaseClass__cast(bi, _ex);
}
struct sidl_BaseInterface__object* 
  impl_sort_QuickSort_fconnect_sidl_BaseInterface(const char* url, sidl_bool ar,
  sidl_BaseInterface *_ex) {
  return sidl_BaseInterface__connectI(url, ar, _ex);
}
struct sidl_BaseInterface__object* 
  impl_sort_QuickSort_fcast_sidl_BaseInterface(void* bi,
  sidl_BaseInterface* _ex) {
  return sidl_BaseInterface__cast(bi, _ex);
}
struct sidl_ClassInfo__object* 
  impl_sort_QuickSort_fconnect_sidl_ClassInfo(const char* url, sidl_bool ar,
  sidl_BaseInterface *_ex) {
  return sidl_ClassInfo__connectI(url, ar, _ex);
}
struct sidl_ClassInfo__object* impl_sort_QuickSort_fcast_sidl_ClassInfo(void* 
  bi, sidl_BaseInterface* _ex) {
  return sidl_ClassInfo__cast(bi, _ex);
}
struct sidl_RuntimeException__object* 
  impl_sort_QuickSort_fconnect_sidl_RuntimeException(const char* url,
  sidl_bool ar, sidl_BaseInterface *_ex) {
  return sidl_RuntimeException__connectI(url, ar, _ex);
}
struct sidl_RuntimeException__object* 
  impl_sort_QuickSort_fcast_sidl_RuntimeException(void* bi,
  sidl_BaseInterface* _ex) {
  return sidl_RuntimeException__cast(bi, _ex);
}
struct sort_Comparator__object* 
  impl_sort_QuickSort_fconnect_sort_Comparator(const char* url, sidl_bool ar,
  sidl_BaseInterface *_ex) {
  return sort_Comparator__connectI(url, ar, _ex);
}
struct sort_Comparator__object* impl_sort_QuickSort_fcast_sort_Comparator(void* 
  bi, sidl_BaseInterface* _ex) {
  return sort_Comparator__cast(bi, _ex);
}
struct sort_Container__object* 
  impl_sort_QuickSort_fconnect_sort_Container(const char* url, sidl_bool ar,
  sidl_BaseInterface *_ex) {
  return sort_Container__connectI(url, ar, _ex);
}
struct sort_Container__object* impl_sort_QuickSort_fcast_sort_Container(void* 
  bi, sidl_BaseInterface* _ex) {
  return sort_Container__cast(bi, _ex);
}
struct sort_Counter__object* impl_sort_QuickSort_fconnect_sort_Counter(const 
  char* url, sidl_bool ar, sidl_BaseInterface *_ex) {
  return sort_Counter__connectI(url, ar, _ex);
}
struct sort_Counter__object* impl_sort_QuickSort_fcast_sort_Counter(void* bi,
  sidl_BaseInterface* _ex) {
  return sort_Counter__cast(bi, _ex);
}
struct sort_QuickSort__object* 
  impl_sort_QuickSort_fconnect_sort_QuickSort(const char* url, sidl_bool ar,
  sidl_BaseInterface *_ex) {
  return sort_QuickSort__connectI(url, ar, _ex);
}
struct sort_QuickSort__object* impl_sort_QuickSort_fcast_sort_QuickSort(void* 
  bi, sidl_BaseInterface* _ex) {
  return sort_QuickSort__cast(bi, _ex);
}
struct sort_SortingAlgorithm__object* 
  impl_sort_QuickSort_fconnect_sort_SortingAlgorithm(const char* url,
  sidl_bool ar, sidl_BaseInterface *_ex) {
  return sort_SortingAlgorithm__connectI(url, ar, _ex);
}
struct sort_SortingAlgorithm__object* 
  impl_sort_QuickSort_fcast_sort_SortingAlgorithm(void* bi,
  sidl_BaseInterface* _ex) {
  return sort_SortingAlgorithm__cast(bi, _ex);
}
