// 
// File:          sort_MergeSort_Impl.cxx
// Symbol:        sort.MergeSort-v0.1
// Symbol Type:   class
// Babel Version: 0.11.0
// Description:   Server-side implementation for sort.MergeSort
// 
// WARNING: Automatically generated; only changes within splicers preserved
// 
// babel-version = 0.11.0
// 
#include "sort_MergeSort_Impl.hxx"

// 
// Includes for all method dependencies.
// 
#ifndef included_sidl_BaseInterface_hxx
#include "sidl_BaseInterface.hxx"
#endif
#ifndef included_sidl_ClassInfo_hxx
#include "sidl_ClassInfo.hxx"
#endif
#ifndef included_sort_Comparator_hxx
#include "sort_Comparator.hxx"
#endif
#ifndef included_sort_Container_hxx
#include "sort_Container.hxx"
#endif
#ifndef included_sort_Counter_hxx
#include "sort_Counter.hxx"
#endif
#line 32 "../../../../babel_0_11_0_final/regression/sort/libUCxx/sort_MergeSort_Impl.cxx"
// DO-NOT-DELETE splicer.begin(sort.MergeSort._includes)
static void
mergeLists(ucxx::sort::Container  &elems,
           ucxx::sort::Comparator &comp,
           ucxx::sort::Counter    &cmp,
           ucxx::sort::Counter    &swp,
           int32_t          start,
           int32_t          mid,
           const int32_t    end)
{
  int32_t j;
  while ((start < mid) && (mid < end)) {
    cmp.inc();
    if (elems.compare(start, mid, comp) > 0) {
      /* move first element of upper list into place */
      for(j = mid;j > start; --j) {
	swp.inc();
	elems.swap(j, j - 1);
      }
      ++mid;
    }
    ++start;
  }
}

/**
 * end is one past the end
 */
static void
mergeSort(ucxx::sort::Container  &elems,
          ucxx::sort::Comparator &comp,
          ucxx::sort::Counter    &cmp,
          ucxx::sort::Counter    &swp,
          const int32_t   start,
          const int32_t   end)
{
  if ((end - start) > 1) {
    int32_t mid = (start + end) >> 1;
    mergeSort(elems, comp, cmp, swp, start, mid);
    mergeSort(elems, comp, cmp, swp, mid, end);
    mergeLists(elems, comp, cmp, swp, start, mid, end);
  }
}
// DO-NOT-DELETE splicer.end(sort.MergeSort._includes)
#line 77 "sort_MergeSort_Impl.cxx"

// user defined constructor
void sort::MergeSort_impl::_ctor() {
#line 79 "../../../../babel_0_11_0_final/regression/sort/libUCxx/sort_MergeSort_Impl.cxx"
  // DO-NOT-DELETE splicer.begin(sort.MergeSort._ctor)
  // add construction details here
  // DO-NOT-DELETE splicer.end(sort.MergeSort._ctor)
#line 85 "sort_MergeSort_Impl.cxx"
}

// user defined destructor
void sort::MergeSort_impl::_dtor() {
#line 86 "../../../../babel_0_11_0_final/regression/sort/libUCxx/sort_MergeSort_Impl.cxx"
  // DO-NOT-DELETE splicer.begin(sort.MergeSort._dtor)
  // add destruction details here
  // DO-NOT-DELETE splicer.end(sort.MergeSort._dtor)
#line 94 "sort_MergeSort_Impl.cxx"
}

// static class initializer
void sort::MergeSort_impl::_load() {
#line 93 "../../../../babel_0_11_0_final/regression/sort/libUCxx/sort_MergeSort_Impl.cxx"
  // DO-NOT-DELETE splicer.begin(sort.MergeSort._load)
  // guaranteed to be called at most once before any other method in this class
  // DO-NOT-DELETE splicer.end(sort.MergeSort._load)
#line 103 "sort_MergeSort_Impl.cxx"
}

// user defined static methods: (none)

// user defined non-static methods:
/**
 * Sort elements using Merge Sort.
 */
void
sort::MergeSort_impl::sort_impl (
  /* in */UCXX ::sort::Container elems,
  /* in */UCXX ::sort::Comparator comp ) 
{
#line 109 "../../../../babel_0_11_0_final/regression/sort/libUCxx/sort_MergeSort_Impl.cxx"
  // DO-NOT-DELETE splicer.begin(sort.MergeSort.sort)
  const int32_t num = elems.getLength();
  ucxx::sort::Counter cmp = getCompareCounter();
  ucxx::sort::Counter swp = getSwapCounter();
  mergeSort(elems, comp, cmp, swp, 0, num);
  // DO-NOT-DELETE splicer.end(sort.MergeSort.sort)
#line 124 "sort_MergeSort_Impl.cxx"
}

/**
 * Return merge sort.
 */
::std::string
sort::MergeSort_impl::getName_impl () 

{
#line 124 "../../../../babel_0_11_0_final/regression/sort/libUCxx/sort_MergeSort_Impl.cxx"
  // DO-NOT-DELETE splicer.begin(sort.MergeSort.getName)
  return "Merge sort";
  // DO-NOT-DELETE splicer.end(sort.MergeSort.getName)
#line 138 "sort_MergeSort_Impl.cxx"
}


#line 130 "../../../../babel_0_11_0_final/regression/sort/libUCxx/sort_MergeSort_Impl.cxx"
// DO-NOT-DELETE splicer.begin(sort.MergeSort._misc)
// Put miscellaneous code here
// DO-NOT-DELETE splicer.end(sort.MergeSort._misc)
#line 146 "sort_MergeSort_Impl.cxx"

