/*
 * File:          sidl_CastException_IOR.h
 * Symbol:        sidl.CastException-v0.9.13
 * Symbol Type:   class
 * Babel Version: 0.11.0
 * Release:       $Name:  $
 * Revision:      @(#) $Id: $
 * Description:   Intermediate Object Representation for sidl.CastException
 * 
 * Copyright (c) 2000-2002, The Regents of the University of California.
 * Produced at the Lawrence Livermore National Laboratory.
 * Written by the Components Team <components@llnl.gov>
 * All rights reserved.
 * 
 * This file is part of Babel. For more information, see
 * http://www.llnl.gov/CASC/components/. Please read the COPYRIGHT file
 * for Our Notice and the LICENSE file for the GNU Lesser General Public
 * License.
 * 
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License (as published by
 * the Free Software Foundation) version 2.1 dated February 1999.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the IMPLIED WARRANTY OF
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the terms and
 * conditions of the GNU Lesser General Public License for more details.
 * 
 * You should have recieved a copy of the GNU Lesser General Public License
 * along with this program; if not, write to the Free Software Foundation,
 * Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 * 
 * WARNING: Automatically generated; changes will be lost
 * 
 * babel-version = 0.11.0
 */

#ifndef included_sidl_CastException_IOR_h
#define included_sidl_CastException_IOR_h

#ifndef included_sidl_header_h
#include "sidl_header.h"
#endif
#ifndef included_sidl_rmi_InstanceHandle_h
#include "sidl_rmi_InstanceHandle.h"
#endif
#ifndef included_sidl_RuntimeException_IOR_h
#include "sidl_RuntimeException_IOR.h"
#endif
#ifndef included_sidl_SIDLException_IOR_h
#include "sidl_SIDLException_IOR.h"
#endif

#ifdef __cplusplus
extern "C" {
#endif

/*
 * Symbol "sidl.CastException" (version 0.9.13)
 * 
 * Exception is thrown when a cast fails and the failure needs to
 * be communicated up the call stack.  (Note: babel _cast does NOT
 * throw this exception)
 */

struct sidl_CastException__array;
struct sidl_CastException__object;

extern struct sidl_CastException__object*
sidl_CastException__new(struct sidl_BaseInterface__object ** _ex);

extern void sidl_CastException__init(
  struct sidl_CastException__object* self,
    struct sidl_BaseInterface__object ** _ex);
extern void sidl_CastException__fini(
  struct sidl_CastException__object* self,
    struct sidl_BaseInterface__object ** _ex);
extern void sidl_CastException__IOR_version(int32_t *major, int32_t *minor);

/*
 * Forward references for external classes and interfaces.
 */

struct sidl_BaseException__array;
struct sidl_BaseException__object;
struct sidl_BaseInterface__array;
struct sidl_BaseInterface__object;
struct sidl_ClassInfo__array;
struct sidl_ClassInfo__object;
struct sidl_io_Deserializer__array;
struct sidl_io_Deserializer__object;
struct sidl_io_Serializer__array;
struct sidl_io_Serializer__object;
struct sidl_rmi_Call__array;
struct sidl_rmi_Call__object;
struct sidl_rmi_Return__array;
struct sidl_rmi_Return__object;

/*
 * Declare the method entry point vector.
 */

struct sidl_CastException__epv {
  /* Implicit builtin methods */
  void* (*f__cast)(
    /* in */ struct sidl_CastException__object* self,
    /* in */ const char* name,
    /* out */ struct sidl_BaseInterface__object* *_ex);
  void (*f__delete)(
    /* in */ struct sidl_CastException__object* self,
    /* out */ struct sidl_BaseInterface__object* *_ex);
  void (*f__exec)(
    /* in */ struct sidl_CastException__object* self,
    /* in */ const char* methodName,
    /* in */ struct sidl_rmi_Call__object* inArgs,
    /* in */ struct sidl_rmi_Return__object* outArgs,
    /* out */ struct sidl_BaseInterface__object* *_ex);
  char* (*f__getURL)(
    /* in */ struct sidl_CastException__object* self,
    /* out */ struct sidl_BaseInterface__object* *_ex);
  void (*f__raddRef)(
    /* in */ struct sidl_CastException__object* self,
    /* out */ struct sidl_BaseInterface__object* *_ex);
  sidl_bool (*f__isRemote)(
    /* in */ struct sidl_CastException__object* self,
    /* out */ struct sidl_BaseInterface__object* *_ex);
  void (*f__ctor)(
    /* in */ struct sidl_CastException__object* self,
    /* out */ struct sidl_BaseInterface__object* *_ex);
  void (*f__dtor)(
    /* in */ struct sidl_CastException__object* self,
    /* out */ struct sidl_BaseInterface__object* *_ex);
  /* Methods introduced in sidl.BaseInterface-v0.9.13 */
  void (*f_addRef)(
    /* in */ struct sidl_CastException__object* self,
    /* out */ struct sidl_BaseInterface__object* *_ex);
  void (*f_deleteRef)(
    /* in */ struct sidl_CastException__object* self,
    /* out */ struct sidl_BaseInterface__object* *_ex);
  sidl_bool (*f_isSame)(
    /* in */ struct sidl_CastException__object* self,
    /* in */ struct sidl_BaseInterface__object* iobj,
    /* out */ struct sidl_BaseInterface__object* *_ex);
  sidl_bool (*f_isType)(
    /* in */ struct sidl_CastException__object* self,
    /* in */ const char* name,
    /* out */ struct sidl_BaseInterface__object* *_ex);
  struct sidl_ClassInfo__object* (*f_getClassInfo)(
    /* in */ struct sidl_CastException__object* self,
    /* out */ struct sidl_BaseInterface__object* *_ex);
  /* Methods introduced in sidl.BaseClass-v0.9.13 */
  /* Methods introduced in sidl.io.Serializable-v0.9.13 */
  void (*f_packObj)(
    /* in */ struct sidl_CastException__object* self,
    /* in */ struct sidl_io_Serializer__object* ser,
    /* out */ struct sidl_BaseInterface__object* *_ex);
  void (*f_unpackObj)(
    /* in */ struct sidl_CastException__object* self,
    /* in */ struct sidl_io_Deserializer__object* des,
    /* out */ struct sidl_BaseInterface__object* *_ex);
  /* Methods introduced in sidl.BaseException-v0.9.13 */
  char* (*f_getNote)(
    /* in */ struct sidl_CastException__object* self,
    /* out */ struct sidl_BaseInterface__object* *_ex);
  void (*f_setNote)(
    /* in */ struct sidl_CastException__object* self,
    /* in */ const char* message,
    /* out */ struct sidl_BaseInterface__object* *_ex);
  char* (*f_getTrace)(
    /* in */ struct sidl_CastException__object* self,
    /* out */ struct sidl_BaseInterface__object* *_ex);
  void (*f_addLine)(
    /* in */ struct sidl_CastException__object* self,
    /* in */ const char* traceline,
    /* out */ struct sidl_BaseInterface__object* *_ex);
  void (*f_add)(
    /* in */ struct sidl_CastException__object* self,
    /* in */ const char* filename,
    /* in */ int32_t lineno,
    /* in */ const char* methodname,
    /* out */ struct sidl_BaseInterface__object* *_ex);
  /* Methods introduced in sidl.SIDLException-v0.9.13 */
  /* Methods introduced in sidl.RuntimeException-v0.9.13 */
  /* Methods introduced in sidl.CastException-v0.9.13 */
};

/*
 * Define the class object structure.
 */

struct sidl_CastException__object {
  struct sidl_SIDLException__object    d_sidl_sidlexception;
  struct sidl_RuntimeException__object d_sidl_runtimeexception;
  struct sidl_CastException__epv*      d_epv;
  void*                                d_data;
};

struct sidl_CastException__external {
  struct sidl_CastException__object*
  (*createObject)(struct sidl_BaseInterface__object **_ex);

  struct sidl_SIDLException__epv*(*getSuperEPV)(void);
};

/*
 * This function returns a pointer to a static structure of
 * pointers to function entry points.  Its purpose is to provide
 * one-stop shopping for loading DLLs.
 */

const struct sidl_CastException__external*
sidl_CastException__externals(void);

struct sidl_BaseClass__object* 
  skel_sidl_CastException_fconnect_sidl_BaseClass(const char* url, sidl_bool ar,
  struct sidl_BaseInterface__object **_ex);
struct sidl_BaseClass__object* 
  skel_sidl_CastException_fcast_sidl_BaseClass(void *bi,
  struct sidl_BaseInterface__object **_ex);

struct sidl_BaseException__object* 
  skel_sidl_CastException_fconnect_sidl_BaseException(const char* url,
  sidl_bool ar, struct sidl_BaseInterface__object **_ex);
struct sidl_BaseException__object* 
  skel_sidl_CastException_fcast_sidl_BaseException(void *bi,
  struct sidl_BaseInterface__object **_ex);

struct sidl_BaseInterface__object* 
  skel_sidl_CastException_fconnect_sidl_BaseInterface(const char* url,
  sidl_bool ar, struct sidl_BaseInterface__object **_ex);
struct sidl_BaseInterface__object* 
  skel_sidl_CastException_fcast_sidl_BaseInterface(void *bi,
  struct sidl_BaseInterface__object **_ex);

struct sidl_CastException__object* 
  skel_sidl_CastException_fconnect_sidl_CastException(const char* url,
  sidl_bool ar, struct sidl_BaseInterface__object **_ex);
struct sidl_CastException__object* 
  skel_sidl_CastException_fcast_sidl_CastException(void *bi,
  struct sidl_BaseInterface__object **_ex);

struct sidl_ClassInfo__object* 
  skel_sidl_CastException_fconnect_sidl_ClassInfo(const char* url, sidl_bool ar,
  struct sidl_BaseInterface__object **_ex);
struct sidl_ClassInfo__object* 
  skel_sidl_CastException_fcast_sidl_ClassInfo(void *bi,
  struct sidl_BaseInterface__object **_ex);

struct sidl_RuntimeException__object* 
  skel_sidl_CastException_fconnect_sidl_RuntimeException(const char* url,
  sidl_bool ar, struct sidl_BaseInterface__object **_ex);
struct sidl_RuntimeException__object* 
  skel_sidl_CastException_fcast_sidl_RuntimeException(void *bi,
  struct sidl_BaseInterface__object **_ex);

struct sidl_SIDLException__object* 
  skel_sidl_CastException_fconnect_sidl_SIDLException(const char* url,
  sidl_bool ar, struct sidl_BaseInterface__object **_ex);
struct sidl_SIDLException__object* 
  skel_sidl_CastException_fcast_sidl_SIDLException(void *bi,
  struct sidl_BaseInterface__object **_ex);

struct sidl_io_Deserializer__object* 
  skel_sidl_CastException_fconnect_sidl_io_Deserializer(const char* url,
  sidl_bool ar, struct sidl_BaseInterface__object **_ex);
struct sidl_io_Deserializer__object* 
  skel_sidl_CastException_fcast_sidl_io_Deserializer(void *bi,
  struct sidl_BaseInterface__object **_ex);

struct sidl_io_Serializable__object* 
  skel_sidl_CastException_fconnect_sidl_io_Serializable(const char* url,
  sidl_bool ar, struct sidl_BaseInterface__object **_ex);
struct sidl_io_Serializable__object* 
  skel_sidl_CastException_fcast_sidl_io_Serializable(void *bi,
  struct sidl_BaseInterface__object **_ex);

struct sidl_io_Serializer__object* 
  skel_sidl_CastException_fconnect_sidl_io_Serializer(const char* url,
  sidl_bool ar, struct sidl_BaseInterface__object **_ex);
struct sidl_io_Serializer__object* 
  skel_sidl_CastException_fcast_sidl_io_Serializer(void *bi,
  struct sidl_BaseInterface__object **_ex);

struct sidl_CastException__remote{
  int d_refcount;
  sidl_rmi_InstanceHandle d_ih;
};

#ifdef __cplusplus
}
#endif
#endif
