/*
 * File:          sidlx_rmi_SimpleServer_Impl.c
 * Symbol:        sidlx.rmi.SimpleServer-v0.1
 * Symbol Type:   class
 * Babel Version: 0.11.0
 * Description:   Server-side implementation for sidlx.rmi.SimpleServer
 * 
 * WARNING: Automatically generated; only changes within splicers preserved
 * 
 * babel-version = 0.11.0
 */

/*
 * DEVELOPERS ARE EXPECTED TO PROVIDE IMPLEMENTATIONS
 * FOR THE FOLLOWING METHODS BETWEEN SPLICER PAIRS.
 */

/*
 * Symbol "sidlx.rmi.SimpleServer" (version 0.1)
 * 
 * A multi-threaded base class for simple network servers.
 * 
 * This server takes the following flags:
 *  1: verbose output (to stdout)
 */

#include "sidlx_rmi_SimpleServer_Impl.h"

#line 29 "../../../babel_0_11_0_final/runtime/sidlx/sidlx_rmi_SimpleServer_Impl.c"
/* DO-NOT-DELETE splicer.begin(sidlx.rmi.SimpleServer._includes) */
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <netdb.h>
#include <errno.h>
#include <sys/param.h>
#include "sidlx_common.h"
#include "sidlx_rmi_Common.h"
#include "sidl_rmi_NetworkException.h"
#include "sidl_String.h"
#ifdef HAVE_PTHREAD
#include <pthread.h>
#endif /* HAVE_PTHREAD */
#define LISTENQ 1024
#define MAXLINE 1023

#ifdef HAVE_PTHREAD
/**
 * This function is executed by child threads dealing with server connections.
 * It just runs the simpleServer serviceRequest, and cleans up after itself on exit.
 */
static void * threadFunc(void *arg) {
  sidl_BaseInterface ex = NULL;
  sidl_BaseException s_b_e = NULL;
  char *str = NULL;
  void ** args = (void**) arg; 
  pthread_detach(pthread_self());
  sidlx_rmi_SimpleServer_serviceRequest( (sidlx_rmi_SimpleServer)args[0], 
					 (sidlx_rmi_Socket) args[1],
					 &ex ); SIDL_CHECK(ex);

  sidlx_rmi_Socket_deleteRef((sidlx_rmi_Socket) args[1], &ex); SIDL_CHECK(ex);
  free(arg);
  close((int)arg);
  return NULL;
 EXIT:
  {
    sidl_BaseInterface throwaway = NULL;
    s_b_e = sidl_BaseException__cast(ex, &throwaway);
    str = sidl_BaseException_getNote(s_b_e, &throwaway);
    printf("ERROR! %s \n",str);
    return NULL;
  }
  
}

/**
 * This function is executed by the thread that acts as server, accepting
 * connections and spawning children to deal with them.  It does not 
 * detatch itself because the main thread may need to join to it to prevent
 * premature exit.
 * It is also designed to work in a nonthreaded enviornment, but I haven't
 * tested that.
 */
#endif /* HAVE_PTHREAD */ 

static void * serverFunc(void *arg) {
  sidlx_rmi_SimpleServer self = (sidlx_rmi_SimpleServer)arg;
  sidlx_rmi_Socket ac_sock = NULL;
  sidl_BaseInterface ex = NULL;
  sidl_BaseException s_b_e = NULL;
  char *str = NULL;
  struct sidlx_rmi_SimpleServer__data *dptr=sidlx_rmi_SimpleServer__get_data(self);
  if(dptr) {    
    for(;;) {
#ifdef HAVE_PTHREAD
      pthread_t tid = 0;
#endif /* HAVE_PTHREAD */ 
      void** args = NULL;
      ac_sock = sidlx_rmi_ServerSocket_accept(dptr->s_sock, &ex); SIDL_CHECK(ex);
      
#ifdef HAVE_PTHREAD
      args = malloc(sizeof(void*)*3);
      args[0] = (void*)self;
      args[1] = (void*)ac_sock;
      pthread_create(&tid, NULL,(void * (*)(void *)) &threadFunc, (void*)args);
#endif /* HAVE_PTHREAD */ 

      if((dptr->d_flags) & 1) { /* If the "verbose" flag is set*/
	printf("SimpleServer: connection\n");
      }
#ifndef HAVE_PTHREAD /* if NOT defined, if we have pthreads, this is called by*/
                     /* the child thread*/
      sidlx_rmi_SimpleServer_serviceRequest( self, ac_sock, &ex );SIDL_CHECK(ex);
#endif /* HAVE_PTHREAD */

      }
      return NULL;
  }

  printf("ERROR! Simple Server not initialized");
  return NULL;
 EXIT:
  {
    sidl_BaseInterface throwaway = NULL;
    s_b_e = sidl_BaseException__cast(ex, &throwaway);
    str = sidl_BaseException_getNote(s_b_e, &throwaway);
    printf("ERROR! %s \n",str);
    return NULL;
  }
  

}


/* DO-NOT-DELETE splicer.end(sidlx.rmi.SimpleServer._includes) */
#line 137 "sidlx_rmi_SimpleServer_Impl.c"

/*
 * Static class initializer called exactly once before any user-defined method is dispatched
 */

#undef __FUNC__
#define __FUNC__ "impl_sidlx_rmi_SimpleServer__load"

#ifdef __cplusplus
extern "C"
#endif
void
impl_sidlx_rmi_SimpleServer__load(
  /* out */ sidl_BaseInterface *_ex)
{
  *_ex = 0;
#line 152 "../../../babel_0_11_0_final/runtime/sidlx/sidlx_rmi_SimpleServer_Impl.c"
  /* DO-NOT-DELETE splicer.begin(sidlx.rmi.SimpleServer._load) */
  /* Insert the implementation of the static class initializer method here... */
  /* DO-NOT-DELETE splicer.end(sidlx.rmi.SimpleServer._load) */
#line 158 "sidlx_rmi_SimpleServer_Impl.c"
}
/*
 * Class constructor called when the class is created.
 */

#undef __FUNC__
#define __FUNC__ "impl_sidlx_rmi_SimpleServer__ctor"

#ifdef __cplusplus
extern "C"
#endif
void
impl_sidlx_rmi_SimpleServer__ctor(
  /* in */ sidlx_rmi_SimpleServer self,
  /* out */ sidl_BaseInterface *_ex)
{
  *_ex = 0;
#line 172 "../../../babel_0_11_0_final/runtime/sidlx/sidlx_rmi_SimpleServer_Impl.c"
  /* DO-NOT-DELETE splicer.begin(sidlx.rmi.SimpleServer._ctor) */
  struct sidlx_rmi_SimpleServer__data *dptr;
  dptr = malloc(sizeof(struct sidlx_rmi_SimpleServer__data));
  dptr->s_sock = sidlx_rmi_ServerSocket__create(_ex); SIDL_CHECK(*_ex);
  sidlx_rmi_SimpleServer__set_data(self, dptr);
 EXIT:
  return;
  /* DO-NOT-DELETE splicer.end(sidlx.rmi.SimpleServer._ctor) */
#line 185 "sidlx_rmi_SimpleServer_Impl.c"
}

/*
 * Class destructor called when the class is deleted.
 */

#undef __FUNC__
#define __FUNC__ "impl_sidlx_rmi_SimpleServer__dtor"

#ifdef __cplusplus
extern "C"
#endif
void
impl_sidlx_rmi_SimpleServer__dtor(
  /* in */ sidlx_rmi_SimpleServer self,
  /* out */ sidl_BaseInterface *_ex)
{
  *_ex = 0;
#line 198 "../../../babel_0_11_0_final/runtime/sidlx/sidlx_rmi_SimpleServer_Impl.c"
  /* DO-NOT-DELETE splicer.begin(sidlx.rmi.SimpleServer._dtor) */
  struct sidlx_rmi_SimpleServer__data * data = sidlx_rmi_SimpleServer__get_data( self );
  if (data) {
    sidlx_rmi_ServerSocket_deleteRef(data->s_sock, _ex);
    free((void*) data);
  }
  sidlx_rmi_SimpleServer__set_data( self, NULL );
  return;
  /* DO-NOT-DELETE splicer.end(sidlx.rmi.SimpleServer._dtor) */
#line 214 "sidlx_rmi_SimpleServer_Impl.c"
}

/*
 * set which port number to bind to
 */

#undef __FUNC__
#define __FUNC__ "impl_sidlx_rmi_SimpleServer_init"

#ifdef __cplusplus
extern "C"
#endif
void
impl_sidlx_rmi_SimpleServer_init(
  /* in */ sidlx_rmi_SimpleServer self,
  /* in */ const char* url,
  /* in */ int32_t flags,
  /* out */ sidl_BaseInterface *_ex)
{
  *_ex = 0;
#line 227 "../../../babel_0_11_0_final/runtime/sidlx/sidlx_rmi_SimpleServer_Impl.c"
  /* DO-NOT-DELETE splicer.begin(sidlx.rmi.SimpleServer.init) */
  struct sidlx_rmi_SimpleServer__data *data=sidlx_rmi_SimpleServer__get_data(self);
  char* myurl = NULL;
  char* protocol = NULL;
  char* server = NULL;
  int port = 0;
  char* objectID= NULL;
  
  if(data && url) {
    data->d_flags = flags;
    myurl = sidl_String_strdup( url );
    sidlx_parseURL(myurl, &protocol, &server, &port, &objectID, _ex);SIDL_CHECK(*_ex);
    
    sidlx_rmi_ServerSocket_init(data->s_sock, port, _ex); SIDL_CHECK(*_ex);
    data->d_port = port;
  }
 EXIT:
  if(myurl) {free((void*)myurl);}
  if(protocol) {free((void*)protocol);}
  if(server) {free((void*)server);}
  if(objectID) {free((void*)objectID);}
  
  return;
  /* DO-NOT-DELETE splicer.end(sidlx.rmi.SimpleServer.init) */
#line 260 "sidlx_rmi_SimpleServer_Impl.c"
}

/*
 * get the port that this Server is bound to
 */

#undef __FUNC__
#define __FUNC__ "impl_sidlx_rmi_SimpleServer_getPort"

#ifdef __cplusplus
extern "C"
#endif
int32_t
impl_sidlx_rmi_SimpleServer_getPort(
  /* in */ sidlx_rmi_SimpleServer self,
  /* out */ sidl_BaseInterface *_ex)
{
  *_ex = 0;
#line 269 "../../../babel_0_11_0_final/runtime/sidlx/sidlx_rmi_SimpleServer_Impl.c"
  /* DO-NOT-DELETE splicer.begin(sidlx.rmi.SimpleServer.getPort) */
  struct sidlx_rmi_SimpleServer__data *data=sidlx_rmi_SimpleServer__get_data(self);
  
  if(data) {
    return data->d_port;
  }
  return 0;
  /* DO-NOT-DELETE splicer.end(sidlx.rmi.SimpleServer.getPort) */
#line 288 "sidlx_rmi_SimpleServer_Impl.c"
}

/*
 * get the flags for this server is configured with
 */

#undef __FUNC__
#define __FUNC__ "impl_sidlx_rmi_SimpleServer_getFlags"

#ifdef __cplusplus
extern "C"
#endif
int32_t
impl_sidlx_rmi_SimpleServer_getFlags(
  /* in */ sidlx_rmi_SimpleServer self,
  /* out */ sidl_BaseInterface *_ex)
{
  *_ex = 0;
#line 295 "../../../babel_0_11_0_final/runtime/sidlx/sidlx_rmi_SimpleServer_Impl.c"
  /* DO-NOT-DELETE splicer.begin(sidlx.rmi.SimpleServer.getFlags) */
  /* Insert-Code-Here {sidlx.rmi.SimpleServer.getFlags} (getFlags method) */
  /* DO-NOT-DELETE splicer.end(sidlx.rmi.SimpleServer.getFlags) */
#line 311 "sidlx_rmi_SimpleServer_Impl.c"
}

/*
 * get the network name of this computer
 */

#undef __FUNC__
#define __FUNC__ "impl_sidlx_rmi_SimpleServer_getServerName"

#ifdef __cplusplus
extern "C"
#endif
char*
impl_sidlx_rmi_SimpleServer_getServerName(
  /* in */ sidlx_rmi_SimpleServer self,
  /* out */ sidl_BaseInterface *_ex)
{
  *_ex = 0;
#line 316 "../../../babel_0_11_0_final/runtime/sidlx/sidlx_rmi_SimpleServer_Impl.c"
  /* DO-NOT-DELETE splicer.begin(sidlx.rmi.SimpleServer.getServerName) */
  char name[MAXHOSTNAMELEN]; /*= sidl_String_alloc(MAXHOSTNAMELEN);*/
  if(gethostname(name, MAXHOSTNAMELEN) == 0) { /*Returns 0 on success*/
    return sidlx_rmi_Common_getCanonicalName(name, _ex);
  }
  /*sidl_String_free(name);*/
  return NULL;
  /* DO-NOT-DELETE splicer.end(sidlx.rmi.SimpleServer.getServerName) */
#line 339 "sidlx_rmi_SimpleServer_Impl.c"
}

/*
 * get the full URL for exporting objects
 */

#undef __FUNC__
#define __FUNC__ "impl_sidlx_rmi_SimpleServer_getServerURL"

#ifdef __cplusplus
extern "C"
#endif
char*
impl_sidlx_rmi_SimpleServer_getServerURL(
  /* in */ sidlx_rmi_SimpleServer self,
  /* in */ const char* objID,
  /* out */ sidl_BaseInterface *_ex)
{
  *_ex = 0;
#line 343 "../../../babel_0_11_0_final/runtime/sidlx/sidlx_rmi_SimpleServer_Impl.c"
  /* DO-NOT-DELETE splicer.begin(sidlx.rmi.SimpleServer.getServerURL) */
  /* TODO: Is there anything we can do here?*/
  return NULL;
  /* DO-NOT-DELETE splicer.end(sidlx.rmi.SimpleServer.getServerURL) */
#line 364 "sidlx_rmi_SimpleServer_Impl.c"
}

/*
 * run the server (must have port specified first), if a threaded server,
 * returns the tid of the server thread for joining.
 */

#undef __FUNC__
#define __FUNC__ "impl_sidlx_rmi_SimpleServer_run"

#ifdef __cplusplus
extern "C"
#endif
int64_t
impl_sidlx_rmi_SimpleServer_run(
  /* in */ sidlx_rmi_SimpleServer self,
  /* out */ sidl_BaseInterface *_ex)
{
  *_ex = 0;
#line 366 "../../../babel_0_11_0_final/runtime/sidlx/sidlx_rmi_SimpleServer_Impl.c"
  /* DO-NOT-DELETE splicer.begin(sidlx.rmi.SimpleServer.run) */
  pthread_t tid = 0;
#ifdef HAVE_PTHREAD
  sidlx_rmi_SimpleServer_addRef(self, _ex); SIDL_CHECK(*_ex);
  pthread_create(&tid, NULL, (void * (*)(void *))&serverFunc, (void*)self);
  return (int64_t)tid;
#else
  serverFunc((void*)self);
#endif /* HAVE_PTHREAD */ 
 EXIT:
  return 0;
  /* DO-NOT-DELETE splicer.end(sidlx.rmi.SimpleServer.run) */
#line 397 "sidlx_rmi_SimpleServer_Impl.c"
}
/* Babel internal methods, Users should not edit below this line. */
struct sidl_BaseClass__object* 
  impl_sidlx_rmi_SimpleServer_fconnect_sidl_BaseClass(const char* url,
  sidl_bool ar, sidl_BaseInterface *_ex) {
  return sidl_BaseClass__connectI(url, ar, _ex);
}
struct sidl_BaseClass__object* 
  impl_sidlx_rmi_SimpleServer_fcast_sidl_BaseClass(void* bi,
  sidl_BaseInterface* _ex) {
  return sidl_BaseClass__cast(bi, _ex);
}
struct sidl_BaseInterface__object* 
  impl_sidlx_rmi_SimpleServer_fconnect_sidl_BaseInterface(const char* url,
  sidl_bool ar, sidl_BaseInterface *_ex) {
  return sidl_BaseInterface__connectI(url, ar, _ex);
}
struct sidl_BaseInterface__object* 
  impl_sidlx_rmi_SimpleServer_fcast_sidl_BaseInterface(void* bi,
  sidl_BaseInterface* _ex) {
  return sidl_BaseInterface__cast(bi, _ex);
}
struct sidl_ClassInfo__object* 
  impl_sidlx_rmi_SimpleServer_fconnect_sidl_ClassInfo(const char* url,
  sidl_bool ar, sidl_BaseInterface *_ex) {
  return sidl_ClassInfo__connectI(url, ar, _ex);
}
struct sidl_ClassInfo__object* 
  impl_sidlx_rmi_SimpleServer_fcast_sidl_ClassInfo(void* bi,
  sidl_BaseInterface* _ex) {
  return sidl_ClassInfo__cast(bi, _ex);
}
struct sidl_RuntimeException__object* 
  impl_sidlx_rmi_SimpleServer_fconnect_sidl_RuntimeException(const char* url,
  sidl_bool ar, sidl_BaseInterface *_ex) {
  return sidl_RuntimeException__connectI(url, ar, _ex);
}
struct sidl_RuntimeException__object* 
  impl_sidlx_rmi_SimpleServer_fcast_sidl_RuntimeException(void* bi,
  sidl_BaseInterface* _ex) {
  return sidl_RuntimeException__cast(bi, _ex);
}
struct sidl_io_Serializable__object* 
  impl_sidlx_rmi_SimpleServer_fconnect_sidl_io_Serializable(const char* url,
  sidl_bool ar, sidl_BaseInterface *_ex) {
  return sidl_io_Serializable__connectI(url, ar, _ex);
}
struct sidl_io_Serializable__object* 
  impl_sidlx_rmi_SimpleServer_fcast_sidl_io_Serializable(void* bi,
  sidl_BaseInterface* _ex) {
  return sidl_io_Serializable__cast(bi, _ex);
}
struct sidl_rmi_BaseServer__object* 
  impl_sidlx_rmi_SimpleServer_fconnect_sidl_rmi_BaseServer(const char* url,
  sidl_bool ar, sidl_BaseInterface *_ex) {
  return sidl_rmi_BaseServer__connectI(url, ar, _ex);
}
struct sidl_rmi_BaseServer__object* 
  impl_sidlx_rmi_SimpleServer_fcast_sidl_rmi_BaseServer(void* bi,
  sidl_BaseInterface* _ex) {
  return sidl_rmi_BaseServer__cast(bi, _ex);
}
struct sidl_rmi_NetworkException__object* 
  impl_sidlx_rmi_SimpleServer_fconnect_sidl_rmi_NetworkException(const char* 
  url, sidl_bool ar, sidl_BaseInterface *_ex) {
  return sidl_rmi_NetworkException__connectI(url, ar, _ex);
}
struct sidl_rmi_NetworkException__object* 
  impl_sidlx_rmi_SimpleServer_fcast_sidl_rmi_NetworkException(void* bi,
  sidl_BaseInterface* _ex) {
  return sidl_rmi_NetworkException__cast(bi, _ex);
}
struct sidl_rmi_ServerInfo__object* 
  impl_sidlx_rmi_SimpleServer_fconnect_sidl_rmi_ServerInfo(const char* url,
  sidl_bool ar, sidl_BaseInterface *_ex) {
  return sidl_rmi_ServerInfo__connectI(url, ar, _ex);
}
struct sidl_rmi_ServerInfo__object* 
  impl_sidlx_rmi_SimpleServer_fcast_sidl_rmi_ServerInfo(void* bi,
  sidl_BaseInterface* _ex) {
  return sidl_rmi_ServerInfo__cast(bi, _ex);
}
struct sidlx_rmi_SimpleServer__object* 
  impl_sidlx_rmi_SimpleServer_fconnect_sidlx_rmi_SimpleServer(const char* url,
  sidl_bool ar, sidl_BaseInterface *_ex) {
  return sidlx_rmi_SimpleServer__connectI(url, ar, _ex);
}
struct sidlx_rmi_SimpleServer__object* 
  impl_sidlx_rmi_SimpleServer_fcast_sidlx_rmi_SimpleServer(void* bi,
  sidl_BaseInterface* _ex) {
  return sidlx_rmi_SimpleServer__cast(bi, _ex);
}
struct sidlx_rmi_Socket__object* 
  impl_sidlx_rmi_SimpleServer_fconnect_sidlx_rmi_Socket(const char* url,
  sidl_bool ar, sidl_BaseInterface *_ex) {
  return sidlx_rmi_Socket__connectI(url, ar, _ex);
}
struct sidlx_rmi_Socket__object* 
  impl_sidlx_rmi_SimpleServer_fcast_sidlx_rmi_Socket(void* bi,
  sidl_BaseInterface* _ex) {
  return sidlx_rmi_Socket__cast(bi, _ex);
}
